#!/usr/bin/env python -i
#------------------------------------------------------------------------------
#
#  This file is part of NuRV (client sample code).
#  Copyright (C) 2018-2021 Fondazione Bruno Kessler (FBK), Italy
#
#  Author: Chun Tian <ctian@fbk.eu>
#------------------------------------------------------------------------------

import sys
from omniORB import CORBA
from omniORB import any
import Monitor
import CosNaming

if len(sys.argv) < 2:
    print "Usage: monitor-client.py -ORBInitRef NameService=IOR:..."
    sys.exit(1)

orb = CORBA.ORB_init(sys.argv, CORBA.ORB_ID)

# Obtain a reference to the root naming context
obj = orb.resolve_initial_references("NameService");
rootContext = obj._narrow(CosNaming.NamingContext)

if rootContext is None:
    print "Failed to narrow the root naming context"
    sys.exit(1)

# Resolve the name "NuRV/Monitor/Service"
name = [CosNaming.NameComponent("NuRV", ""),
        CosNaming.NameComponent("Monitor", ""),
        CosNaming.NameComponent("Service", "")]
try:
    obj = rootContext.resolve(name)

except CosNaming.NamingContext.NotFound, ex:
    print "Name not found"
    sys.exit(1)

# Narrow the object to an Example::Echo
service = obj._narrow(Monitor.MonitorService)

if service is None:
    print "Object reference is not an Monitor::Service"
    sys.exit(1)

# Sample usage:
#
# service.heartbeat(to_any(0), "p & q")
# service.reset(to_any("p0"))
