# Monitor synthesis demo based on FBK's nuXmv model checker

This folder contains demo files for sending to Kaspersky.

The code is updated with latest interface (as of March 4, 2018).

The monitoring LTL property is `G (p -> X X q)` (or `ALWAYS (p ==>
NEXT NEXT q)`), i.e. whenever event `p` happens, the 2nd next event must be `q`.

Here are sample outputs (by executing ./app)

<pre>
2018-03-05 12:12:00.704 [Command] HEARTBEAT(q) ... OK
2018-03-05 12:12:00.905 [Command] HEARTBEAT(p) ... OK
2018-03-05 12:12:01.108 [Command] HEARTBEAT(p) ... OK
2018-03-05 12:12:01.308 [Command] HEARTBEAT(q) ... OK
2018-03-05 12:12:01.510 [Command] HEARTBEAT(p) ... FAIL
2018-03-05 12:12:01.511 [Command] RESET
2018-03-05 12:12:01.713 [Command] HEARTBEAT(p) ... OK
2018-03-05 12:12:01.917 [Command] HEARTBEAT(q) ... OK
2018-03-05 12:12:02.122 [Command] HEARTBEAT(p) ... FAIL
2018-03-05 12:12:02.122 [Command] RESET
2018-03-05 12:12:02.325 [Command] HEARTBEAT(p) ... OK
2018-03-05 12:12:02.528 [Command] HEARTBEAT(q) ... OK
2018-03-05 12:12:02.729 [Command] HEARTBEAT(p) ... FAIL
2018-03-05 12:12:02.729 [Command] RESET
2018-03-05 12:12:02.933 [Command] HEARTBEAT(p) ... OK
2018-03-05 12:12:03.137 [Command] HEARTBEAT(p) ... OK
2018-03-05 12:12:03.342 [Command] HEARTBEAT(q) ... OK
2018-03-05 12:12:03.542 [Command] HEARTBEAT(q) ... OK
2018-03-05 12:12:03.747 [Command] HEARTBEAT(p) ... OK
</pre>

The system model (`disjoint.smv`) indicates that events `p` and `q`
never happen together. Use `all.smv` to remove such restrictions.

The file `default.ord` indicates that `p` is encoded *first* (least
significant bit), then `q`. Thus `p & !q` is encoded as binary `01`.

See also `auto.pdf` for the deterministic finite state machine (FSM)
built for monitoring above property.
